/* branch.cc            This is a part of SimuAlpha Version 2.2a
 *                      Copyright (c) 1999,2000,2001, Kenji KISE
 ***************************************************************/
#include <string.h>
#include <iostream.h>
#include "define.h"

/*
 * Execute Unconditional Branch, BR and BSR
 **********************************************************/
ADDR_TYPE execute_jmp(ADDR_TYPE *pc, DATA_TYPE Rbv){
  ADDR_TYPE ret=*pc;
  *pc = Rbv & 0xFFFFFFFFFFFFFFFcull;
  return ret;
}

/*
 * Execute Unconditional Branch, BR and BSR
 **********************************************************/
ADDR_TYPE execute_branch(ADDR_TYPE *pc, DATA_TYPE diff21){
  ADDR_TYPE ret=*pc;
  *pc += 4*diff21;
  return ret;
}

/*
 * Execute Integer Conditional Branch
 **********************************************************/
void ex_branch(int code, ADDR_TYPE *pc,
	       DATA_TYPE Rav, DATA_TYPE dif){
  double Fav=0.0;
  //  signal(SIGFPE, (void *)signal_float_branch);
  switch(code)
    {
    case 0x39: if(Rav==0)            *pc += 4*dif;break;
    case 0x3e: if((long long)Rav>=0) *pc += 4*dif;break;
    case 0x3f: if((long long)Rav>0)  *pc += 4*dif;break;
    case 0x38: if(!(Rav & 1))        *pc += 4*dif;break;
    case 0x3c: if(  Rav & 1 )        *pc += 4*dif;break;
    case 0x3b: if((long long)Rav<=0) *pc += 4*dif;break;
    case 0x3a: if((long long)Rav<0 ) *pc += 4*dif;break;
    case 0x3d: if(Rav!=0)            *pc += 4*dif;break;

    case 0x31: memcpy(&Fav,&Rav,8);if(Fav==0.0) *pc+=4*dif;break;
    case 0x36: memcpy(&Fav,&Rav,8);if(Fav>=0.0) *pc+=4*dif;break;
    case 0x37: memcpy(&Fav,&Rav,8);if(Fav> 0.0) *pc+=4*dif;break;
    case 0x33: memcpy(&Fav,&Rav,8);if(Fav<=0.0) *pc+=4*dif;break;
    case 0x32: memcpy(&Fav,&Rav,8);if(Fav< 0.0) *pc+=4*dif;break;
    case 0x35: memcpy(&Fav,&Rav,8);if(Fav!=0.0) *pc+=4*dif;break;
    }
  //  signal(SIGFPE, SIG_IGN);
}
