#include <stdio.h>
#include <iostream.h>
#include <iomanip.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include "define.h"

/* global variables */
extern class architecture_state as;
extern struct evaluate e;

extern FILE *outfile;
extern char *get_assem_a(unsigned int ir, unsigned long long pc);
DATA_TYPE get_hex(char *buf);

extern Imemory Imem; // Instruction Memory
extern Dmemory Dmem;

void print_reg_name(int i){
  switch(i){
  case 0:   printf("v0    "); break;
  case 1:   printf("t0    "); break;
  case 2:   printf("t1    "); break;
  case 3:   printf("t2    "); break;
  case 4:   printf("t3    "); break;
  case 5:   printf("t4    "); break;
  case 6:   printf("t5    "); break;
  case 7:   printf("t6    "); break;
  case 8:   printf("t7    "); break;
  case 9:   printf("s0    "); break;
  case 10:  printf("s1    "); break;
  case 11:  printf("s2    "); break;
  case 12:  printf("s3    "); break;
  case 13:  printf("s4    "); break;
  case 14:  printf("s5    "); break;
  case 15:  printf("fp    "); break;
  case 16:  printf("a0    "); break;
  case 17:  printf("a1    "); break;
  case 18:  printf("a2    "); break;
  case 19:  printf("a3    "); break;
  case 20:  printf("a4    "); break;
  case 21:  printf("a5    "); break;
  case 22:  printf("t8    "); break;
  case 23:  printf("t9    "); break;
  case 24:  printf("t10   "); break;
  case 25:  printf("t11   "); break;
  case 26:  printf("ra    "); break;
  case 27:  printf("t12   "); break;
  case 28:  printf("at    "); break;
  case 29:  printf("gp    "); break;
  case 30:  printf("sp    "); break;
  case 31:  printf("zero  "); break;
  case 32:  printf("pc    "); break;
  case 33:  printf("vfp   "); break;
  }
}
    

/***********************************************************/
void print_status()
{
  int i;
  unsigned int ir;
  
  ir =  Imem.instruction_load(as.pc);
  cout << dec <<"TC:" << e.retired_inst << "  ";
  cout << hex << "0x" << as.pc;
  cout << "          " << get_assem_a(ir, as.pc+4) << "\n";
  
  /*  printf(" mem val 0x%llx\n",  load_8byte(0x11ffffb80));  */
  /*  printf("f1            0x%-16llx %-8f \n", as.f[1],as.f[1]); */

  for(i=0; i<32; i++){
    print_reg_name(i);
    cout << "r" << dec << setfill('0') << setw(2) << i << "      " ;
    cout.setf(ios::left);
    cout << "0x" << hex << setw(9) << setfill(' ') << as.r[i] << " ";
    cout << dec << setw(9) << setfill(' ') << as.r[i] << "\n";
  }
  
  cout << "pc             ";
  cout.setf(ios::left);
  cout << "0x" << hex << setw(9) << setfill(' ') << as.pc << " ";
  cout << dec << setw(9) << setfill(' ') << as.pc << "\n";

  cout << "npc            ";
  cout.setf(ios::left);
  cout << "0x" << hex << setw(9) << setfill(' ') << 0 << " ";
  cout << dec << setw(9) << setfill(' ') << 0 << "\n";
}


/************************************************************/
void debugmode() /* -d option is added */
{
  int i,j;
  char t_buf[256];
  char t_temp[256];
  static int stop = 1;
  ULL tmp;

  char *buf;
  char *temp;
  
  static ULL stop_count = 0;
  static ADDR_TYPE stop_address = 0xFFFFFFFFFFFFFFFFull; 
  ADDR_TYPE address;

  buf = t_buf;
  temp = t_temp;

  if(stop_count==e.retired_inst){
    stop = 1;
  }

  if(stop_address==as.pc){
    stop = 1;
  }

  if(stop==0) return;
  
  if(stop==1){

    print_status();
    
    printf("(db)");
    fgets(buf,256, stdin);

    while(*buf != (char)NULL){
      
      if(!strncmp(buf,"quit",4)) exit(1);
      if(!strncmp(buf,"h",1)){ /* help */
	printf("  command\n");
	printf("  c followd by number:  stop specified tc.\n");
	printf("  s followd by address: stop specified address.\n");
	printf("  x followd by address: examine specified address.\n");
	printf("  quit: quit simulate.\n");
      }

      if(*(buf)=='\n') break;

      if(*(buf)=='x'){
	buf++;
	address = get_hex(buf);
	address = address >> 4; /* I don't know why? */

	for(j=0; j<40; j++){
	  printf("0x%x%x: ",(int)(address >> 32),(int)(address & MASK32));
	  for(i=0; i<2; i++){
	    tmp = Dmem.load_8byte(address);
	    printf("0x%08x%08x ", (int)(tmp >> 32), (int)(tmp & MASK32));
	    address +=8;
	  }
	  printf("\n");
	}
      }

      
      if(*(buf)=='c'){ /* stop by total count */
	buf++;
	stop_count = atol(buf); /* for int use atoi */
	cout << "stop_tc = " << dec << stop_count << "\n";
	stop=0;
	break;
      }

      if(*(buf)=='s'){ /* stop by address */
	buf++;
	stop_address  = get_hex(buf);
	stop_address  = stop_address >> 4;
	cout << "stop_address = " << hex << "0x" << stop_address << "\n";
	stop=0;
	break;
      }
      
      cout << "\n" << "(db)";
      fgets(buf,256,stdin);
    }
  }
  
}

/*
 * convert hexadecimal value into decimal value
 **************************************************/
ULL get_hex(char *buf){
  int i;
  int num;
  char t;
  ULL temp=0;
  ULL sum;

  sum=0;
  num = strlen(buf);

  if(num>16){
    printf("Error! hex() can treat within 16digit numbers.\n");
    exit(1);
  }
  
  for(i=0; i<num; i++){
    t = *((char *)(buf+(num-i-1)));
    
    switch(t)
      {
      case '0': temp = 0;break;
      case '1': temp = 1;break;
      case '2': temp = 2;break;
      case '3': temp = 3;break;
      case '4': temp = 4;break;
      case '5': temp = 5;break;
      case '6': temp = 6;break;
      case '7': temp = 7;break;
      case '8': temp = 8;break;
      case '9': temp = 9;break;
      case 'a': temp = 10;break;
      case 'b': temp = 11;break;
      case 'c': temp = 12;break;
      case 'd': temp = 13;break;
      case 'e': temp = 14;break;
      case 'f': temp = 15;break;
      }
    sum += temp * (unsigned long long)(1llu << 4*i);
  }
  return sum;
}

