/* decode.cc            This is a part of SimuAlpha Version 2.2a
 *                      Copyright (c) 1999,2000,2001, Kenji KISE
 ***************************************************************/
#include <stdio.h>
#include "define.h"

int get_iclass(ULL ir){
  int code;
  int func;
  code = (ir >> 26) & 0x3F;
  func = func11(ir);
  switch(code)
    {
    case 0x0a: return EX_LDI;
    case 0x0e: return EX_STI;
    case 0x0d: return EX_STI;
      
    case 0x18: return EX_OPM;
    case 0x00: return EX_PAL;
    case 0x1a: return EX_JMP;
      
    case 0x30:
    case 0x34: return EX_BRA;
      
    case 0x38:
    case 0x39:
    case 0x3a:
    case 0x3b:
    case 0x3c:
    case 0x3d:
    case 0x3e:
    case 0x3f: return EX_CBI;
      
    case 0x31:
    case 0x32:
    case 0x33:
    case 0x35:
    case 0x36:
    case 0x37: return EX_CBF;
      
    case 0x10: return EX_ARI;
    case 0x11:
      switch(func & 0x7F){
      case 0x24:
      case 0x46:
      case 0x66:
      case 0x16:
      case 0x14:
      case 0x64:
      case 0x44:
      case 0x26: return EX_CMI; /* Conditional Move Integer */
      default: return EX_ARI;
      }
    case 0x12: return EX_ARI;
    case 0x13: return EX_ARI;
      
    case 0x08:
    case 0x09: return EX_ADR;
      
    case 0x28:
    case 0x29:
    case 0x0b: return EX_LDI;
      
    case 0x22:
    case 0x23: return EX_LDF;

    case 0x2d:
    case 0x0f:
    case 0x2c: return EX_STI;
      
    case 0x26:
    case 0x27: return EX_STF;
      
    case 0x16: return EX_FLO;
    case 0x17:
      switch(func){
      case 0x02a:
      case 0x02b: return EX_CMF; /* Conditional Move Floag */
      default: return EX_FLO;
      }
    }
  return -1;
}  
